import { Cookie } from "./cookie.js";
import type { Auth, Session, User } from "./index.js";
export type LuciaRequest = {
    method: string;
    url: string;
    headers: {
        origin: string | null;
        cookie: string | null;
    };
};
export type RequestContext = {
    request: LuciaRequest;
    setCookie: (cookie: Cookie) => void;
};
export type Middleware<Args extends any[] = any> = (...args: Args) => RequestContext;
export declare class AuthRequest<A extends Auth = any, Context extends RequestContext = any> {
    private auth;
    private context;
    constructor(auth: A, context: Context);
    private validatePromise;
    private validateUserPromise;
    private currentSession;
    setSession: (session: Session | null) => void;
    validate: () => Promise<Session | null>;
    validateUser: () => Promise<{
        user: null;
        session: null;
    } | {
        user: User;
        session: Session;
    }>;
    getCookie: () => Cookie | null;
}
